'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _rcColorPicker = require('rc-color-picker');

var _rcColorPicker2 = _interopRequireDefault(_rcColorPicker);

var _utils = require('../utils');

var _rcEditorUtils = require('rc-editor-utils');

var _rcEditorUtils2 = _interopRequireDefault(_rcEditorUtils);

var _ColorPickerBtn = require('./ColorPickerBtn');

var _ColorPickerBtn2 = _interopRequireDefault(_ColorPickerBtn);

require('rc-color-picker/assets/index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

var getCurrentInlineStyle = _rcEditorUtils2["default"].getCurrentInlineStyle,
    getCurrentEntity = _rcEditorUtils2["default"].getCurrentEntity;

var defaultFontColor = '000';
var PREFIX = 'FONTCOLOR_';
var fontColor = {
    constructor: function constructor(config) {
        var callbacks = {
            getEditorState: _utils.noop,
            setEditorState: _utils.noop
        };
        var applyStyle = (0, _utils.getApplyFontStyleFunc)(PREFIX, callbacks);
        function changeSelect(_ref) {
            var color = _ref.color;

            var colorString = color.substring(1);
            applyStyle('' + PREFIX + colorString);
        }
        function customStyleFn(styleSet) {
            return styleSet.map(function (style) {
                if (style.indexOf(PREFIX) !== -1) {
                    var color = '#' + style.substring(PREFIX.length);
                    return {
                        color: color
                    };
                }
                return {};
            }).reduce(function (prev, curr) {
                return Object.assign(prev, curr);
            });
        }
        return {
            name: 'fontColor',
            callbacks: callbacks,
            customStyleFn: customStyleFn,
            component: function component(props) {
                var editorState = callbacks.getEditorState();
                var currentStyle = getCurrentInlineStyle(editorState);
                var currentFontColor = currentStyle && currentStyle.find(function (item) {
                    return item.indexOf('' + PREFIX) !== -1;
                });
                var fontColor = currentFontColor ? currentFontColor.substring(PREFIX.length) : defaultFontColor;
                return React.createElement(_rcColorPicker2["default"], { defaultColor: '#' + defaultFontColor, animation: "slide-up", color: '#' + fontColor, onChange: changeSelect }, React.createElement(_ColorPickerBtn2["default"], null));
            }
        };
    }
};
exports["default"] = fontColor;
module.exports = exports['default'];